import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { Button, DatePicker, Input, Select } from 'antd'
import { E4FormType } from './type'
import { useDispatch, useSelector } from 'react-redux'
import { E4_APIdel, E4_APIgetList } from '@/store/action/E4repair'
import { E1InputKeyType } from '../E1accident/type'
import { MessageFu } from '@/utils/message'
import history, { btnFlagFu } from '@/utils/history'
import { FourTableType } from '@/pages/B_enterTibet/B1collect/type'
import MyPopconfirm from '@/components/MyPopconfirm'
import { RootState } from '@/store'
import dayjs from 'dayjs'
import { E4tableC, statusObj } from '@/utils/tableData'
import ExportJsonExcel from 'js-export-excel'
import { selectObj } from '@/utils/select'
import MyTable from '@/components/MyTable'
const { RangePicker } = DatePicker

const E4baseFormData: E4FormType = {
  pageSize: 10,
  pageNum: 1,
  num: '',
  dateStart: '',
  dateEnd: '',
  userName: '',
  userType: ''
}

function E4repair() {
  const dispatch = useDispatch()

  const [formData, setFormData] = useState(E4baseFormData)
  const formDataRef = useRef(E4baseFormData)
  const formDataOldRef = useRef(E4baseFormData)

  useEffect(() => {
    formDataRef.current = formData
  }, [formData])

  // 点击搜索的 时间戳
  const [timeKey, setTimeKey] = useState(0)

  // 点击搜索
  const clickSearch = useCallback(() => {
    setFormData({ ...formData, pageNum: 1 })
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [formData])

  // 时间选择器改变
  const timeChange = useCallback(
    (date: any, dateString: any) => {
      let dateStart = ''
      let dateEnd = ''
      if (dateString[0] && dateString[1]) {
        dateStart = dateString[0] + ' 00:00:00'
        dateEnd = dateString[1] + ' 23:59:59'
      }
      setFormData({ ...formData, dateStart, dateEnd })
    },
    [formData]
  )

  // 封装发送请求的函数
  const getListFu = useCallback(() => {
    formDataOldRef.current = { ...formDataRef.current }
    dispatch(E4_APIgetList(formDataRef.current))
  }, [dispatch])

  useEffect(() => {
    getListFu()
  }, [getListFu, timeKey])

  // 输入框的改变
  const txtChangeFu = useCallback(
    (txt: string, key: E1InputKeyType) => {
      setFormData({
        ...formData,
        [key]: txt
      })
    },
    [formData]
  )

  // 点击重置
  const resetSelectFu = useCallback(() => {
    setFormData(E4baseFormData)
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [])

  // 页码变化
  const paginationChange = useCallback(
    (pageNum: number, pageSize: number) => {
      setFormData({ ...formData, pageNum, pageSize })
      setTimeout(() => {
        setTimeKey(Date.now())
      }, 50)
    },
    [formData]
  )

  // 点击删除
  const delTableFu = useCallback(
    async (id: number) => {
      const res = await E4_APIdel(id)
      if (res.code === 0) {
        MessageFu.success('删除成功')
        getListFu()
      }
    },
    [getListFu]
  )

  // 点击操作按钮
  const tableBtnFu = useCallback((id: number, key: string) => {
    history.push(`/repair_edit/${key}/${id}`)
  }, [])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: FourTableType) => {
          let obj = btnFlagFu(item)
          return !Object.values(obj).some(Boolean) ? (
            '-'
          ) : (
            <>
              {obj['编辑'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '2')}>
                  编辑
                </Button>
              ) : null}

              {obj['审批'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '3')}>
                  审批
                </Button>
              ) : null}
              {obj['查看'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '4')}>
                  查看
                </Button>
              ) : null}

              {obj['删除'] ? (
                <MyPopconfirm txtK='删除' onConfirm={() => delTableFu(item.id)} />
              ) : null}
            </>
          )
        }
      }
    ]
  }, [delTableFu, tableBtnFu])

  // 从仓库拿数据
  const tableInfo = useSelector((state: RootState) => state.E4repair.tableInfo)

  // 点击导出
  const deriveFu = useCallback(async () => {
    const name = '文物修复' + dayjs(new Date()).format('YYYY-MM-DD HH:mm')

    const res = await E4_APIgetList(
      {
        ...formDataOldRef.current,
        pageNum: 1,
        pageSize: 99999
      },
      true
    )

    if (res.code === 0) {
      if (res.data.records.length <= 0) return MessageFu.warning('当前搜索条件没有数据!')

      const option = {
        fileName: name,
        datas: [
          {
            sheetData: res.data.records.map((v: FourTableType) => ({
              ...v,
              status: statusObj[v.status as 1]
            })),
            sheetName: name,
            sheetFilter: ['num', 'dateStart', 'authUnit', 'creatorName', 'createTime', 'status'],
            sheetHeader: ['申请编号', '交修日期', '交修部门', '发起人', '发送日期', '申请状态'],
            columnWidths: [10, 10, 10, 10, 10, 10]
          }
        ]
      }

      const toExcel = new ExportJsonExcel(option) //new
      toExcel.saveExcel() //保存
    }
  }, [])

  return (
    <div className={styles.E4repair}>
      <div className='pageTitle'>文物修复</div>
      <div className='E4top'>
        <div className='E4top1'>
          <div>
            <span>申请编号：</span>
            <Input
              placeholder='请输入申请编号'
              maxLength={30}
              value={formData.num}
              onChange={e => txtChangeFu(e.target.value, 'num')}
            />
          </div>

          <div>
            <span>交修日期范围：</span>
            <RangePicker
              value={
                formData.dateStart ? [dayjs(formData.dateStart), dayjs(formData.dateEnd)] : null
              }
              onChange={timeChange}
            />
          </div>

          <div>
            <span>发起人：</span>
            <Input
              placeholder='请输入发起人'
              maxLength={30}
              value={formData.userName}
              onChange={e => txtChangeFu(e.target.value, 'userName')}
            />
          </div>

          <div>
            <span>选择角色：</span>
            <Select
              allowClear={true}
              style={{ width: 150 }}
              placeholder='全部'
              options={selectObj['角色']}
              // fieldNames={{ value: 'id', label: 'roleName' }}
              value={formData.userType ? formData.userType : null}
              onChange={e => setFormData({ ...formData, userType: e })}
            />
          </div>
        </div>
        <div className='E4top2'>
          <Button type='primary' onClick={deriveFu}>
            批量导出
          </Button>
          &emsp;
          <Button type='primary' onClick={() => history.push('/repair_edit/1/null')}>
            新增
          </Button>
          &emsp;
          <Button type='primary' onClick={clickSearch}>
            查询
          </Button>
          &emsp;<Button onClick={resetSelectFu}>重置</Button>
        </div>
      </div>

      {/* 表格 */}
      <MyTable
        yHeight={650}
        list={tableInfo.list}
        columnsTemp={E4tableC}
        lastBtn={tableLastBtn}
        pageNum={formData.pageNum}
        pageSize={formData.pageSize}
        total={tableInfo.total}
        onChange={(pageNum, pageSize) => paginationChange(pageNum, pageSize)}
      />
    </div>
  )
}

const MemoE4repair = React.memo(E4repair)

export default MemoE4repair
